﻿
using System.Collections.Generic;
using HeuristicLab.Problems.RoutePlanning.Osm;
namespace HeuristicLab.Problems.RoutePlanning.Graph {
  public class Graph {
    private IDataSource dataSource;
    private Dictionary<Node, List<Node>> vertexEdges;
    private Dictionary<long, Vertex<Node>> vertices;
    private Dictionary<Way, Dictionary<long, List<Vertex<Node>>>> resolvedList;

    public Graph(IDataSource ds) {
      dataSource = ds;
      vertexEdges = new Dictionary<Node, List<Node>>();
      vertices = new Dictionary<long, Vertex<Node>>();
      resolvedList = new Dictionary<Way, Dictionary<long, List<Vertex<Node>>>>();
    }

    public Vertex<Node> GetVertex(long id) {
      return new Vertex<Node>(dataSource.GetNode(id));
    }

    public List<Way> GetEdges(Vertex<Node> vertex) {
      return dataSource.GetWays(vertex.Node);
    }

    //public Dictionary<long, float> GetNeighbours(long id) {
    //  Vertex<Node> vertex = GetVertex(id);
    //  Dictionary<long, float> neighbors = new Dictionary<long, float>();
    //  IList<Way> edges = GetEdges(vertex);
    //  foreach (Way edge in edges) {

    //  }
    //  return null;
    //}

  }
}
